Index: ntoskrnl/ob/object.c
===================================================================
--- ntoskrnl/ob/object.c	(revision 21808)
+++ ntoskrnl/ob/object.c	(working copy)
@@ -22,7 +22,7 @@
 typedef struct _RETENTION_CHECK_PARAMS
 {
   WORK_QUEUE_ITEM WorkItem;
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
 } RETENTION_CHECK_PARAMS, *PRETENTION_CHECK_PARAMS;
 
 /* FUNCTIONS ************************************************************/
@@ -298,7 +298,7 @@
   PVOID NextObject;
   PVOID CurrentObject;
   PVOID RootObject;
-  POBJECT_HEADER CurrentHeader;
+  PROS_OBJECT_HEADER CurrentHeader;
   NTSTATUS Status;
   PWSTR current;
   UNICODE_STRING PathString;
@@ -384,7 +384,7 @@
 	     DPRINT("Current object can't parse\n");
 	     break;
 	  }
-	Status = CurrentHeader->Type->TypeInfo.ParseProcedure(CurrentObject,
+	Status = ((OB_ROS_PARSE_METHOD)CurrentHeader->Type->TypeInfo.ParseProcedure)(CurrentObject,
 						  &NextObject,
 						  &PathString,
 						  &current,
@@ -441,7 +441,7 @@
                   OUT PULONG ReturnLength)
 {
     POBJECT_HEADER_NAME_INFO LocalInfo;
-    POBJECT_HEADER ObjectHeader;
+    PROS_OBJECT_HEADER ObjectHeader;
     PDIRECTORY_OBJECT ParentDirectory;
     ULONG NameSize;
     PWCH ObjectName;
@@ -459,6 +459,7 @@
         /* Call the procedure */
         DPRINT("Calling Object's Procedure\n");
         Status = ObjectHeader->Type->TypeInfo.QueryNameProcedure(Object,
+                                                                 TRUE, //fixme
                                                                  ObjectNameInfo,
                                                                  Length,
                                                                  ReturnLength);
@@ -618,9 +619,9 @@
                   PUNICODE_STRING ObjectName,
                   POBJECT_TYPE ObjectType,
                   ULONG ObjectSize,
-                  POBJECT_HEADER *ObjectHeader)
+                  PROS_OBJECT_HEADER *ObjectHeader)
 {
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     BOOLEAN HasHandleInfo = FALSE;
     BOOLEAN HasNameInfo = FALSE;
     BOOLEAN HasCreatorInfo = FALSE;
@@ -684,7 +685,7 @@
         HandleInfo = (POBJECT_HEADER_HANDLE_INFO)Header;
         DPRINT("Info: %x\n", HandleInfo);
         HandleInfo->SingleEntry.HandleCount = 0;
-        Header = (POBJECT_HEADER)(HandleInfo + 1);
+        Header = (PROS_OBJECT_HEADER)(HandleInfo + 1);
     }
        
     /* Initialize the Object Name Info */
@@ -694,7 +695,7 @@
         DPRINT("Info: %x %wZ\n", NameInfo, ObjectName);
         NameInfo->Name = *ObjectName;
         NameInfo->Directory = NULL;
-        Header = (POBJECT_HEADER)(NameInfo + 1);
+        Header = (PROS_OBJECT_HEADER)(NameInfo + 1);
     }
     
     /* Initialize Creator Info */
@@ -706,7 +707,7 @@
          * CreatorInfo->CreatorUniqueProcess = PsGetCurrentProcessId();
          */
         InitializeListHead(&CreatorInfo->TypeList);
-        Header = (POBJECT_HEADER)(CreatorInfo + 1);
+        Header = (PROS_OBJECT_HEADER)(CreatorInfo + 1);
     }
     
     /* Initialize the object header */
@@ -777,7 +778,7 @@
     NTSTATUS Status;
     POBJECT_CREATE_INFORMATION ObjectCreateInfo;
     UNICODE_STRING ObjectName;
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     
     DPRINT("ObCreateObject(Type %p ObjectAttributes %p, Object %p)\n", 
             Type, ObjectAttributes, Object);
@@ -845,7 +846,7 @@
 			   IN POBJECT_TYPE ObjectType,
 			   IN KPROCESSOR_MODE AccessMode)
 {
-   POBJECT_HEADER Header;
+   PROS_OBJECT_HEADER Header;
 
    /* NOTE: should be possible to reference an object above APC_LEVEL! */
 
@@ -938,7 +939,7 @@
 
 
 static NTSTATUS
-ObpDeleteObject(POBJECT_HEADER Header)
+ObpDeleteObject(PROS_OBJECT_HEADER Header)
 {
   PVOID HeaderLocation = Header;
   POBJECT_HEADER_HANDLE_INFO HandleInfo;
@@ -1015,7 +1016,7 @@
 
 
 STATIC NTSTATUS
-ObpDeleteObjectDpcLevel(IN POBJECT_HEADER ObjectHeader,
+ObpDeleteObjectDpcLevel(IN PROS_OBJECT_HEADER ObjectHeader,
 			IN LONG OldPointerCount)
 {
 #if 0
@@ -1094,7 +1095,7 @@
 VOID FASTCALL
 ObfReferenceObject(IN PVOID Object)
 {
-  POBJECT_HEADER Header;
+  PROS_OBJECT_HEADER Header;
 
   ASSERT(Object);
 
@@ -1127,7 +1128,7 @@
 VOID FASTCALL
 ObfDereferenceObject(IN PVOID Object)
 {
-  POBJECT_HEADER Header;
+  PROS_OBJECT_HEADER Header;
   LONG NewPointerCount;
   BOOL Permanent;
 
@@ -1222,7 +1223,7 @@
 ULONG STDCALL
 ObGetObjectPointerCount(PVOID Object)
 {
-  POBJECT_HEADER Header;
+  PROS_OBJECT_HEADER Header;
 
   PAGED_CODE();
 
@@ -1250,7 +1251,7 @@
 NTAPI
 ObGetObjectHandleCount(PVOID Object)
 {
-  POBJECT_HEADER Header;
+  PROS_OBJECT_HEADER Header;
 
   PAGED_CODE();
 
Index: ntoskrnl/ob/symlink.c
===================================================================
--- ntoskrnl/ob/symlink.c	(revision 21808)
+++ ntoskrnl/ob/symlink.c	(working copy)
@@ -152,7 +152,7 @@
   ObjectTypeInitializer.PoolType = NonPagedPool;
   ObjectTypeInitializer.ValidAccessMask = SYMBOLIC_LINK_ALL_ACCESS;
   ObjectTypeInitializer.UseDefaultObject = TRUE;
-  ObjectTypeInitializer.ParseProcedure = ObpParseSymbolicLink;
+  ObjectTypeInitializer.ParseProcedure = (OB_PARSE_METHOD)ObpParseSymbolicLink;
   ObjectTypeInitializer.DeleteProcedure = ObpDeleteSymbolicLink;
   ObpCreateTypeObject(&ObjectTypeInitializer, &Name, &ObSymbolicLinkType);
 }
Index: ntoskrnl/ob/security.c
===================================================================
--- ntoskrnl/ob/security.c	(revision 21808)
+++ ntoskrnl/ob/security.c	(working copy)
@@ -66,7 +66,7 @@
 		    OUT PSECURITY_DESCRIPTOR *SecurityDescriptor,
 		    OUT PBOOLEAN MemoryAllocated)
 {
-  POBJECT_HEADER Header;
+  PROS_OBJECT_HEADER Header;
   ULONG Length;
   NTSTATUS Status;
 
@@ -161,7 +161,7 @@
 {
     KPROCESSOR_MODE PreviousMode;
     PVOID Object;
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     ACCESS_MASK DesiredAccess = (ACCESS_MASK)0;
     NTSTATUS Status = STATUS_SUCCESS;
 
@@ -240,7 +240,7 @@
 {
     KPROCESSOR_MODE PreviousMode;
     PVOID Object;
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     SECURITY_DESCRIPTOR_RELATIVE *CapturedSecurityDescriptor;
     ACCESS_MASK DesiredAccess = (ACCESS_MASK)0;
     NTSTATUS Status;
Index: ntoskrnl/ob/dirobj.c
===================================================================
--- ntoskrnl/ob/dirobj.c	(revision 21808)
+++ ntoskrnl/ob/dirobj.c	(working copy)
@@ -223,7 +223,7 @@
                                            BufferLength);
     if(TemporaryBuffer != NULL)
     {
-      POBJECT_HEADER EntryHeader;
+      PROS_OBJECT_HEADER EntryHeader;
       PLIST_ENTRY ListEntry;
       KIRQL OldLevel;
       ULONG RequiredSize = sizeof(OBJECT_DIRECTORY_INFORMATION);
@@ -244,7 +244,7 @@
           PUNICODE_STRING Name, Type;
           ULONG EntrySize;
 
-          EntryHeader = CONTAINING_RECORD(ListEntry, OBJECT_HEADER, Entry);
+          EntryHeader = CONTAINING_RECORD(ListEntry, ROS_OBJECT_HEADER, Entry);
 
           /* calculate the size of the required buffer space for this entry */
           Name = (HEADER_TO_OBJECT_NAME(EntryHeader)->Name.Length != 0 ? &HEADER_TO_OBJECT_NAME(EntryHeader)->Name : NULL);
Index: ntoskrnl/ob/handle.c
===================================================================
--- ntoskrnl/ob/handle.c	(revision 21808)
+++ ntoskrnl/ob/handle.c	(working copy)
@@ -52,7 +52,7 @@
 static VOID
 ObpDecrementHandleCount(PVOID ObjectBody)
 {
-  POBJECT_HEADER ObjectHeader = BODY_TO_HEADER(ObjectBody);
+  PROS_OBJECT_HEADER ObjectHeader = BODY_TO_HEADER(ObjectBody);
   LONG NewHandleCount = InterlockedDecrement(&ObjectHeader->HandleCount);
   DPRINT("Header: %x\n", ObjectHeader);
   DPRINT("NewHandleCount: %x\n", NewHandleCount);
@@ -63,7 +63,7 @@
   {
     /* the handle count should be decremented but we pass the previous value
        to the callback */
-    ObjectHeader->Type->TypeInfo.CloseProcedure(ObjectBody, NewHandleCount + 1);
+    ObjectHeader->Type->TypeInfo.CloseProcedure(NULL, ObjectBody, 0, NewHandleCount + 1, NewHandleCount + 1);
   }
 
   if(NewHandleCount == 0)
@@ -75,7 +75,7 @@
       /* delete the object from the namespace when the last handle got closed.
          Only do this if it's actually been inserted into the namespace and
          if it's not a permanent object. */
-      ObpRemoveEntryDirectory(ObjectHeader);
+      ObpRemoveEntryDirectory((PROS_OBJECT_HEADER)ObjectHeader);
     }
 
     /* remove the keep-alive reference */
@@ -123,8 +123,8 @@
                                           Handle);
   if (HandleTableEntry != NULL)
   {
-    HandleInfo->Inherit = (HandleTableEntry->u1.ObAttributes & EX_HANDLE_ENTRY_INHERITABLE) != 0;
-    HandleInfo->ProtectFromClose = (HandleTableEntry->u1.ObAttributes & EX_HANDLE_ENTRY_PROTECTFROMCLOSE) != 0;
+    HandleInfo->Inherit = (HandleTableEntry->ObAttributes & EX_HANDLE_ENTRY_INHERITABLE) != 0;
+    HandleInfo->ProtectFromClose = (HandleTableEntry->ObAttributes & EX_HANDLE_ENTRY_PROTECTFROMCLOSE) != 0;
 
     ExUnlockHandleTableEntry(Process->ObjectTable,
                              HandleTableEntry);
@@ -183,14 +183,14 @@
   if (HandleTableEntry != NULL)
   {
     if (HandleInfo->Inherit)
-      HandleTableEntry->u1.ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
+      HandleTableEntry->ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
     else
-      HandleTableEntry->u1.ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
+      HandleTableEntry->ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
 
     if (HandleInfo->ProtectFromClose)
-      HandleTableEntry->u1.ObAttributes |= EX_HANDLE_ENTRY_PROTECTFROMCLOSE;
+      HandleTableEntry->ObAttributes |= EX_HANDLE_ENTRY_PROTECTFROMCLOSE;
     else
-      HandleTableEntry->u1.ObAttributes &= ~EX_HANDLE_ENTRY_PROTECTFROMCLOSE;
+      HandleTableEntry->ObAttributes &= ~EX_HANDLE_ENTRY_PROTECTFROMCLOSE;
 
     /* FIXME: Do we need to set anything in the object header??? */
 
@@ -216,7 +216,7 @@
 {
    PHANDLE_TABLE_ENTRY HandleEntry;
    PVOID Body;
-   POBJECT_HEADER ObjectHeader;
+   PROS_OBJECT_HEADER ObjectHeader;
    PHANDLE_TABLE ObjectTable;
 
    PAGED_CODE();
@@ -231,7 +231,7 @@
                                       Handle);
    if(HandleEntry != NULL)
    {
-     if(HandleEntry->u1.ObAttributes & EX_HANDLE_ENTRY_PROTECTFROMCLOSE)
+     if(HandleEntry->ObAttributes & EX_HANDLE_ENTRY_PROTECTFROMCLOSE)
      {
        ExUnlockHandleTableEntry(ObjectTable,
                                 HandleEntry);
@@ -274,7 +274,7 @@
   HANDLE_TABLE_ENTRY NewHandleEntry;
   BOOLEAN AttachedToProcess = FALSE;
   PVOID ObjectBody;
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
   ULONG NewHandleCount;
   HANDLE NewTargetHandle;
   PEPROCESS CurrentProcess;
@@ -316,17 +316,17 @@
   ObjectHeader = EX_HTE_TO_HDR(SourceHandleEntry);
   ObjectBody = &ObjectHeader->Body;
 
-  NewHandleEntry.u1.Object = SourceHandleEntry->u1.Object;
+  NewHandleEntry.Object = SourceHandleEntry->Object;
   if(HandleAttributes & OBJ_INHERIT)
-    NewHandleEntry.u1.ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
+    NewHandleEntry.ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
   else
-    NewHandleEntry.u1.ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
-  NewHandleEntry.u2.GrantedAccess = ((Options & DUPLICATE_SAME_ACCESS) ?
-                                     SourceHandleEntry->u2.GrantedAccess :
+    NewHandleEntry.ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
+  NewHandleEntry.GrantedAccess = ((Options & DUPLICATE_SAME_ACCESS) ?
+                                     SourceHandleEntry->GrantedAccess :
                                      DesiredAccess);
   if (Options & DUPLICATE_SAME_ACCESS)
   {
-    NewHandleEntry.u2.GrantedAccess = SourceHandleEntry->u2.GrantedAccess;
+    NewHandleEntry.GrantedAccess = SourceHandleEntry->GrantedAccess;
   }
   else
   {
@@ -335,7 +335,7 @@
       RtlMapGenericMask(&DesiredAccess,
                         &ObjectHeader->Type->TypeInfo.GenericMapping);
     }
-    NewHandleEntry.u2.GrantedAccess = DesiredAccess;
+    NewHandleEntry.GrantedAccess = DesiredAccess;
   }
 
   /* reference the object so it doesn't get deleted after releasing the lock
@@ -613,7 +613,7 @@
                     ULONG GrantedAccess,
                     PVOID Context)
 {
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
   PVOID ObjectBody;
 
   PAGED_CODE();
@@ -629,12 +629,12 @@
                         PHANDLE_TABLE_ENTRY HandleTableEntry,
                         PVOID Context)
 {
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
   BOOLEAN Ret = FALSE;
 
   PAGED_CODE();
 
-  Ret = (HandleTableEntry->u1.ObAttributes & EX_HANDLE_ENTRY_INHERITABLE) != 0;
+  Ret = (HandleTableEntry->ObAttributes & EX_HANDLE_ENTRY_INHERITABLE) != 0;
   if(Ret)
   {
     ObjectHeader = EX_HTE_TO_HDR(HandleTableEntry);
@@ -709,7 +709,7 @@
 {
    HANDLE_TABLE_ENTRY NewEntry;
    PEPROCESS Process, CurrentProcess;
-   POBJECT_HEADER ObjectHeader;
+   PROS_OBJECT_HEADER ObjectHeader;
    HANDLE Handle;
    KAPC_STATE ApcState;
    BOOLEAN AttachedToProcess = FALSE;
@@ -739,12 +739,12 @@
 		         &ObjectHeader->Type->TypeInfo.GenericMapping);
      }
 
-   NewEntry.u1.Object = ObjectHeader;
+   NewEntry.Object = ObjectHeader;
    if(HandleAttributes & OBJ_INHERIT)
-     NewEntry.u1.ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
+     NewEntry.ObAttributes |= EX_HANDLE_ENTRY_INHERITABLE;
    else
-     NewEntry.u1.ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
-   NewEntry.u2.GrantedAccess = GrantedAccess;
+     NewEntry.ObAttributes &= ~EX_HANDLE_ENTRY_INHERITABLE;
+   NewEntry.GrantedAccess = GrantedAccess;
 
    if ((HandleAttributes & OBJ_KERNEL_HANDLE) &&
        ExGetPreviousMode == KernelMode)
@@ -834,7 +834,7 @@
                                      Handle);
   if(HandleEntry != NULL)
   {
-    *GenerateOnClose = (HandleEntry->u1.ObAttributes & EX_HANDLE_ENTRY_AUDITONCLOSE) != 0;
+    *GenerateOnClose = (HandleEntry->ObAttributes & EX_HANDLE_ENTRY_AUDITONCLOSE) != 0;
 
     ExUnlockHandleTableEntry(Process->ObjectTable,
                              HandleEntry);
@@ -877,7 +877,7 @@
 			  POBJECT_HANDLE_INFORMATION HandleInformation)
 {
    PHANDLE_TABLE_ENTRY HandleEntry;
-   POBJECT_HEADER ObjectHeader;
+   PROS_OBJECT_HEADER ObjectHeader;
    PVOID ObjectBody;
    ACCESS_MASK GrantedAccess;
    ULONG Attributes;
@@ -1013,7 +1013,7 @@
                           &BODY_TO_HEADER(ObjectBody)->Type->TypeInfo.GenericMapping);
      }
 
-   GrantedAccess = HandleEntry->u2.GrantedAccess;
+   GrantedAccess = HandleEntry->GrantedAccess;
 
    /* Unless running as KernelMode, deny access if caller desires more access
       rights than the handle can grant */
@@ -1036,7 +1036,7 @@
 
    ObReferenceObject(ObjectBody);
 
-   Attributes = HandleEntry->u1.ObAttributes & (EX_HANDLE_ENTRY_PROTECTFROMCLOSE |
+   Attributes = HandleEntry->ObAttributes & (EX_HANDLE_ENTRY_PROTECTFROMCLOSE |
                                                 EX_HANDLE_ENTRY_INHERITABLE |
                                                 EX_HANDLE_ENTRY_AUDITONCLOSE);
 
@@ -1141,10 +1141,10 @@
                OUT PHANDLE Handle)
 {
     POBJECT_CREATE_INFORMATION ObjectCreateInfo;
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     POBJECT_HEADER_NAME_INFO ObjectNameInfo;
     PVOID FoundObject = NULL;
-    POBJECT_HEADER FoundHeader = NULL;
+    PROS_OBJECT_HEADER FoundHeader = NULL;
     NTSTATUS Status = STATUS_SUCCESS;
     UNICODE_STRING RemainingPath;
     BOOLEAN ObjectAttached = FALSE; 
@@ -1203,7 +1203,7 @@
         PWSTR BufferPos = RemainingPath.Buffer;
         ULONG Delta = 0;
         
-        ObpAddEntryDirectory(FoundObject, Header, NULL);
+        ObpAddEntryDirectory(FoundObject, (PROS_OBJECT_HEADER)Header, NULL);
         ObjectAttached = TRUE;
         
         ObjectNameInfo = HEADER_TO_OBJECT_NAME(Header);
@@ -1251,8 +1251,8 @@
         {
             DPRINT("Calling %x\n", Header->Type->TypeInfo.OpenProcedure);
             Status = Header->Type->TypeInfo.OpenProcedure(ObCreateHandle,
+                                                                NULL,
                                                                 &Header->Body,
-                                                                NULL,
                                                                 0,
                                                                 0);
         }
@@ -1262,7 +1262,7 @@
             DPRINT("Create Failed\n");
             if (ObjectAttached == TRUE)
             {
-                ObpRemoveEntryDirectory(Header);
+                ObpRemoveEntryDirectory((PROS_OBJECT_HEADER)Header);
             }
             if (FoundObject)
             {
Index: ntoskrnl/ob/ntobj.c
===================================================================
--- ntoskrnl/ob/ntobj.c	(revision 21808)
+++ ntoskrnl/ob/ntobj.c	(working copy)
@@ -86,7 +86,7 @@
 	       OUT PULONG ResultLength  OPTIONAL)
 {
   OBJECT_HANDLE_INFORMATION HandleInfo;
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
   ULONG InfoLength;
   PVOID Object;
   NTSTATUS Status;
@@ -220,7 +220,7 @@
 VOID FASTCALL
 ObpSetPermanentObject (IN PVOID ObjectBody, IN BOOLEAN Permanent)
 {
-  POBJECT_HEADER ObjectHeader;
+  PROS_OBJECT_HEADER ObjectHeader;
 
   ObjectHeader = BODY_TO_HEADER(ObjectBody);
   ASSERT (ObjectHeader->PointerCount > 0);
@@ -234,7 +234,7 @@
      if (ObjectHeader->HandleCount == 0 && HEADER_TO_OBJECT_NAME(ObjectHeader)->Directory)
      {
         /* Remove the object from the namespace */
-        ObpRemoveEntryDirectory(ObjectHeader);
+        ObpRemoveEntryDirectory((PROS_OBJECT_HEADER)ObjectHeader);
      }
   }
 }
Index: ntoskrnl/rtl/libsupp.c
===================================================================
--- ntoskrnl/rtl/libsupp.c	(revision 21808)
+++ ntoskrnl/rtl/libsupp.c	(working copy)
@@ -292,8 +292,8 @@
    HANDLE Handle;
    USHORT HandleIndex;
    
-   ExEntry.u1.Object = Entry;
-   ExEntry.u2.GrantedAccess = 0x1; /* FIXME - valid handle */
+   ExEntry.Object = Entry;
+   ExEntry.GrantedAccess = 0x1; /* FIXME - valid handle */
    
    Handle = ExCreateHandle(AtomTable->ExHandleTable,
                                 &ExEntry);
@@ -330,7 +330,7 @@
                                   (HANDLE)((ULONG_PTR)Index << 2));
    if (ExEntry != NULL)
    {
-      Entry = ExEntry->u1.Object;
+      Entry = ExEntry->Object;
       
       ExUnlockHandleTableEntry(AtomTable->ExHandleTable,
                                ExEntry);
Index: ntoskrnl/se/semgr.c
===================================================================
--- ntoskrnl/se/semgr.c	(revision 21808)
+++ ntoskrnl/se/semgr.c	(working copy)
@@ -212,7 +212,7 @@
   PISECURITY_DESCRIPTOR ObjectSd;
   PISECURITY_DESCRIPTOR NewSd;
   PISECURITY_DESCRIPTOR SecurityDescriptor = _SecurityDescriptor;
-  POBJECT_HEADER Header = BODY_TO_HEADER(Object);
+  PROS_OBJECT_HEADER Header = BODY_TO_HEADER(Object);
   PSID Owner = 0;
   PSID Group = 0;
   PACL Dacl = 0;
Index: ntoskrnl/io/efi.c
===================================================================
--- ntoskrnl/io/efi.c	(revision 21808)
+++ ntoskrnl/io/efi.c	(working copy)
@@ -39,8 +39,8 @@
 NTSTATUS
 STDCALL
 NtEnumerateBootEntries(
-	IN ULONG Unknown1,
-	IN ULONG Unknown2
+    IN PVOID Buffer,
+    IN PULONG BufferLength
 	)
 {
 	UNIMPLEMENTED;
@@ -50,8 +50,8 @@
 NTSTATUS
 STDCALL
 NtQueryBootEntryOrder(
-	IN ULONG Unknown1,
-	IN ULONG Unknown2
+    IN PULONG Ids,
+    IN PULONG Count
 	)
 {
 	UNIMPLEMENTED;
@@ -61,8 +61,8 @@
 NTSTATUS
 STDCALL
 NtQueryBootOptions(
-	IN ULONG Unknown1,
-	IN ULONG Unknown2
+    IN PBOOT_OPTIONS BootOptions,
+    IN PULONG BootOptionsLength
 	)
 {
 	UNIMPLEMENTED;
@@ -72,8 +72,8 @@
 NTSTATUS
 STDCALL
 NtSetBootEntryOrder(
-	IN ULONG Unknown1,
-	IN ULONG Unknown2
+    IN PULONG Ids,
+    IN PULONG Count
 	)
 {
 	UNIMPLEMENTED;
@@ -83,8 +83,8 @@
 NTSTATUS
 STDCALL
 NtSetBootOptions(
-	ULONG Unknown1,
-	ULONG Unknown2
+    IN PBOOT_OPTIONS BootOptions,
+    IN ULONG FieldsToChange
 	)
 {
 	UNIMPLEMENTED;
@@ -94,9 +94,10 @@
 NTSTATUS
 STDCALL
 NtTranslateFilePath(
-	ULONG Unknown1,
-	ULONG Unknown2,
-	ULONG Unknown3
+    PFILE_PATH InputFilePath,
+    ULONG OutputType,
+    PFILE_PATH OutputFilePath,
+    ULONG OutputFilePathLength
 	)
 {
 	UNIMPLEMENTED;
Index: ntoskrnl/io/disk.c
===================================================================
--- ntoskrnl/io/disk.c	(revision 21808)
+++ ntoskrnl/io/disk.c	(working copy)
@@ -65,7 +65,26 @@
 
 HAL_PRIVATE_DISPATCH HalPrivateDispatchTable =
 {
-    HAL_PRIVATE_DISPATCH_VERSION
+    HAL_PRIVATE_DISPATCH_VERSION,
+    (pHalHandlerForBus) NULL,
+    (pHalHandlerForConfigSpace) NULL,
+    (pHalLocateHiberRanges) NULL,
+    (pHalRegisterBusHandler) NULL,
+    (pHalSetWakeEnable) NULL,
+    (pHalSetWakeAlarm) NULL,
+    (pHalTranslateBusAddress) NULL,
+    (pHalAssignSlotResources) NULL,
+    (pHalHaltSystem) NULL,
+    (pHalFindBusAddressTranslation) NULL,
+    (pHalResetDisplay) NULL,
+    (pHalAllocateMapRegisters) NULL,
+    (pKdSetupPciDeviceForDebugging) NULL,
+    (pKdReleasePciDeviceForDebugging) NULL,
+    (pKdGetAcpiTablePhase0) NULL,
+    (pKdCheckPowerButton) NULL,
+    (pHalVectorToIDTEntry) NULL,
+    (pKdMapPhysicalMemory64) NULL,
+    (pKdUnmapVirtualAddress) NULL
 };
 
 const WCHAR DiskMountString[] = L"\\DosDevices\\%C:";
@@ -597,7 +616,7 @@
 
 
 VOID FASTCALL
-xHalIoAssignDriveLetters(IN PLOADER_PARAMETER_BLOCK LoaderBlock,
+xHalIoAssignDriveLetters(IN PROS_LOADER_PARAMETER_BLOCK LoaderBlock,
 			 IN PSTRING NtDeviceName,
 			 OUT PUCHAR NtSystemPath,
 			 OUT PSTRING NtSystemPathString)
Index: ntoskrnl/io/driver.c
===================================================================
--- ntoskrnl/io/driver.c	(revision 21808)
+++ ntoskrnl/io/driver.c	(working copy)
@@ -15,8 +15,6 @@
 #include <internal/debug.h>
 
 /* ke/main.c */
-extern LOADER_PARAMETER_BLOCK KeLoaderBlock;
-extern ULONG KeTickCount;
 extern BOOLEAN SetupMode;
 extern BOOLEAN NoGuiBoot;
 
Index: ntoskrnl/io/iomgr.c
===================================================================
--- ntoskrnl/io/iomgr.c	(revision 21808)
+++ ntoskrnl/io/iomgr.c	(working copy)
@@ -424,7 +424,7 @@
     KdbInit();
 
     /* I/O is now setup for disk access, so phase 3 */
-    KdInitSystem(3, (PLOADER_PARAMETER_BLOCK)&KeLoaderBlock);
+    KdInitSystem(3, (PROS_LOADER_PARAMETER_BLOCK)&KeLoaderBlock);
 
     /* Load services for devices found by PnP manager */
     IopInitializePnpServices(IopRootDeviceNode, FALSE);
Index: ntoskrnl/io/file.c
===================================================================
--- ntoskrnl/io/file.c	(revision 21808)
+++ ntoskrnl/io/file.c	(working copy)
@@ -397,6 +397,7 @@
 NTSTATUS
 STDCALL
 IopQueryNameFile(PVOID ObjectBody,
+                 IN BOOLEAN HasName,
                  POBJECT_NAME_INFORMATION ObjectNameInfo,
                  ULONG Length,
                  PULONG ReturnLength)
@@ -456,8 +457,11 @@
 
 VOID
 STDCALL
-IopCloseFile(PVOID ObjectBody,
-             ULONG HandleCount)
+IopCloseFile(IN PEPROCESS Process OPTIONAL,
+             IN PVOID ObjectBody,
+             IN ACCESS_MASK GrantedAccess,
+             IN ULONG HandleCount,
+             IN ULONG SystemHandleCount)
 {
     PFILE_OBJECT FileObject = (PFILE_OBJECT)ObjectBody;
     KEVENT Event;
Index: ntoskrnl/io/plugplay.c
===================================================================
--- ntoskrnl/io/plugplay.c	(revision 21808)
+++ ntoskrnl/io/plugplay.c	(working copy)
@@ -539,8 +539,8 @@
     _SEH_TRY
     {
 	Relation = RelatedDeviceData->Relation;
-	MaximumLength = RelatedDeviceData->RelatedDeviceInstance.MaximumLength;
-	ProbeForWrite(RelatedDeviceData->RelatedDeviceInstance.Buffer,
+	MaximumLength = RelatedDeviceData->RelatedDeviceInstanceLength;
+	ProbeForWrite(RelatedDeviceData->RelatedDeviceInstance,
 	              MaximumLength,
 		      sizeof(WCHAR));
     }
@@ -622,10 +622,10 @@
     /* Copy related device instance name */
     _SEH_TRY
     {
-        RtlCopyMemory(RelatedDeviceData->RelatedDeviceInstance.Buffer,
+        RtlCopyMemory(RelatedDeviceData->RelatedDeviceInstance,
                       RelatedDeviceNode->InstancePath.Buffer,
                       RelatedDeviceNode->InstancePath.Length);
-        RelatedDeviceData->RelatedDeviceInstance.Length = RelatedDeviceNode->InstancePath.Length;
+        RelatedDeviceData->RelatedDeviceInstanceLength = RelatedDeviceNode->InstancePath.Length;
     }
     _SEH_HANDLE
     {
